#ifndef __NEURAL_NET_NETWORK_H
#define __NEURAL_NET_NETWORK_H

struct layer {
  int N;
  int fieldsz;
  int shared;
  int act;
  int wsz;
  int useBias;
  int useResidual;
  double *weights;
  double *dw, *delta, *deltaw, *dy;
  int *widx, *bidx, *rwidx;
  int **inputidx;
  double *out0;
  double *out;
  int gn;
};

struct network {
  int L;
  struct layer* layers;
};

extern struct network* create_net(char* netfile, int train);
extern void print_net(char* netfile, struct network* net);
extern void del_net(struct network* net);

extern double* response(struct network* net, int* input);
extern void computegradient(struct network* net, int* input, double* target, int* valid, int resp);
extern void update(struct network* net);

extern double* wsize(struct network* net);
extern double* dwsize(struct network* net);
extern int layersN(struct network* net);

extern void unshareTop(struct network* net);

extern double RANDW;
extern double eta, etaC, mu;
extern double wdecay;
extern int updateRule;

#endif
