#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include "nparams.h"

struct nparams {
  char** s;
  FILE* f;
  int n;
};

struct nparams* init_nparams(char* fname) {
  struct nparams* npar = malloc(sizeof(struct nparams));
  npar->f = fopen(fname, "r");
  char buff[10000];
  if (npar->f == NULL) {
    sprintf(buff, "opening %s", fname);
    perror(buff);
    exit(1);
  }
  npar->s = malloc(1000*sizeof(char*));
  npar->n = 0;
  while (fgets(buff, 10000, npar->f)) {
    npar->s[npar->n] = strdup(buff);
    npar->n++;
  }

  return npar;
}

void close_nparams(struct nparams* npar) {
  free(npar->s);
  fclose(npar->f);
  free(npar);
}


int getVal_int(struct nparams* npar, int l, const char* name, int defval) {
  int i;
  int v;
  for (i = 0; i < npar->n; i++) {
    char format[1000];
    if (l == -1) 
      sprintf(format, "%s=%%d", name);
    else 
      sprintf(format, "%d:%s=%%d", l, name);
    if (sscanf(npar->s[i], format, &v) == 1) 
      return v;
  }
  return defval;
}

double getVal_dbl(struct nparams* npar, int l, const char* name, double defval) {
  int i;
  double v;
  for (i = 0; i < npar->n; i++) {
    char format[1000];
    if (l == -1) 
      sprintf(format, "%s=%%f", name);
    else 
      sprintf(format, "%d:%s=%%f", l, name);
    if (sscanf(npar->s[i], format, &v) == 1) 
      return v;
  }
  return defval;
}



