%{
#include <stdio.h>
#include <stdlib.h>
#include "sgf-defs.h"

#define YYSTACKSIZE 100000

extern int yylex();
extern int yyparse();
extern int yyline;
extern char *yytext;
extern void yyerror(char* s);
extern void yyerrorf(const char* fmt, ... );

char* sgf2gtpMove(char *str, char* mstr);

int handicap_mode = 0;
%}

%union {
	int ptype;
}

//%type <seq> sequence node properties

%token <ptype> AL_PROPID
%token AL_PAR_O AL_PAR_C AL_SC AL_PROPVAL

%%

collection:	gametree gametrees
gametrees:	gametree gametrees | ;
gametree:	AL_PAR_O sequence 
                gametrees AL_PAR_C
sequence:	node sequence 
		| ;
node:		AL_SC properties 
properties:	AL_PROPID AL_PROPVAL 
                { 
		  if ($1 == PT_SZ) {
		    int sz;
		    sscanf(yytext+1, "%d", &sz);
		    printf("boardsize %d\n", sz);
		    printf("clear_board\n");
		  }
		  if ($1 == PT_BR) {
		    // ...
		  }
		  if ($1 == PT_WR) {
		    // ...
		  }
		  if ($1 == PT_HA) {
		    int ha;
		    if ((sscanf(yytext+1, "%d", &ha) == 1) && (ha>=2)){
		      yyerrorf("handicap game");
		      handicap_mode = 1;
		    }
		  }
		  if (!handicap_mode){
		    if ($1 == PT_RE) {
		      int res;	
		      if (yytext[1] == 'B') res = RE_BW; else
		      if (yytext[1] == 'W') res = RE_WW; else
			res = RE_EMPTY; 
			// print res...
		    }
		    if (($1 == PT_B) || ($1 == PT_W)) {
		      // int move = sgf2move(yytext+1);
		      // print move ... 
		      char move[4];
		      printf("play %c %s\n", ($1==PT_B)?'B':'W', sgf2gtpMove(yytext+1, move));
		    }
		    if ($1 == PT_C){
		    }
		  } /* endif !handicap_mode */
		}
                propvals properties 
                {
		}
	        | ;
propvals:	AL_PROPVAL propvals | ;

%%

extern FILE *yyin;


int main(int argc, char** argv){
  if (argc == 2) {
    yyin = fopen(argv[1], "r");
    if (yyin == NULL) {
      perror("");
      exit(1);
    }
  }

  yyparse();

  fclose(yyin);

  return 0;
}

#include <string.h>
char* sgf2gtpMove(char *str, char* mstr){
  if (str[0] < 'i')
    mstr[0] = str[0];
  else 
    mstr[0] = str[0]+1;
  sprintf(mstr+1, "%d", 19-(str[1]-'a'));
  return mstr;
}

